"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var each_1 = __importDefault(require("licia/each"));
var index_1 = __importDefault(require("./index"));
var hooks_1 = require("../share/hooks");
var LunaDomViewer = function (props) {
    var domViewerRef = (0, react_1.useRef)(null);
    var domViewer = (0, react_1.useRef)();
    var prevProps = (0, hooks_1.usePrevious)(props);
    (0, react_1.useEffect)(function () {
        domViewer.current = new index_1.default(domViewerRef.current, {
            theme: props.theme,
            hotkey: props.hotkey,
            node: props.node,
            ignore: props.ignore,
            ignoreAttr: props.ignoreAttr,
            observe: props.observe,
            lowerCaseTagName: props.lowerCaseTagName,
        });
        props.onCreate && props.onCreate(domViewer.current);
        return function () { var _a; return (_a = domViewer.current) === null || _a === void 0 ? void 0 : _a.destroy(); };
    }, []);
    (0, hooks_1.useEvent)(domViewer, 'select', prevProps === null || prevProps === void 0 ? void 0 : prevProps.onSelect, props.onSelect);
    (0, hooks_1.useEvent)(domViewer, 'deselect', prevProps === null || prevProps === void 0 ? void 0 : prevProps.onDeselect, props.onDeselect);
    (0, each_1.default)(['theme'], function (key) {
        (0, hooks_1.useOption)(domViewer, key, props[key]);
    });
    return (0, jsx_runtime_1.jsx)("div", { ref: domViewerRef });
};
exports.default = LunaDomViewer;
