import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useRef } from 'react';
import each from 'licia/each';
import DomViewer from './index';
import { useEvent, useOption, usePrevious } from '../share/hooks';
const LunaDomViewer = (props) => {
    const domViewerRef = useRef(null);
    const domViewer = useRef();
    const prevProps = usePrevious(props);
    useEffect(() => {
        domViewer.current = new DomViewer(domViewerRef.current, {
            theme: props.theme,
            hotkey: props.hotkey,
            node: props.node,
            ignore: props.ignore,
            ignoreAttr: props.ignoreAttr,
            observe: props.observe,
            lowerCaseTagName: props.lowerCaseTagName,
        });
        props.onCreate && props.onCreate(domViewer.current);
        return () => domViewer.current?.destroy();
    }, []);
    useEvent(domViewer, 'select', prevProps?.onSelect, props.onSelect);
    useEvent(domViewer, 'deselect', prevProps?.onDeselect, props.onDeselect);
    each(['theme'], (key) => {
        useOption(domViewer, key, props[key]);
    });
    return _jsx("div", { ref: domViewerRef });
};
export default LunaDomViewer;
